diff --git a/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
similarity index 80%
rename from src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
index 573f74fbe..ce9e4d09d 100644
--- a/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
@@ -21,7 +21,7 @@ public class BlockCropsPumpkin
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
         int meta = world.getBlockMetadata(x, y, z);
         float onePix = 1.0F / 16.0F;
         float size = 0.0f;
@@ -37,7 +37,7 @@ public class BlockCropsPumpkin
             size = 14 * onePix;
         }
 
-        setBlockBounds(0.5F - size / 2, 0, 0.5F - size / 2, 0.5F + size / 2, size, 0.5F + size / 2);
+        return AABB.getTemporaryBB(0.5F - size / 2, 0, 0.5F - size / 2, 0.5F + size / 2, size, 0.5F + size / 2);
     }
 
     @Override
@@ -70,17 +70,17 @@ public class BlockCropsPumpkin
 
     private float getGrowthRate(World world, int x, int y, int z) {
         float growthRate = 1.0F;
-        int idNegZ = world.getBlockId(x, y, z - 1);
-        int idPosZ = world.getBlockId(x, y, z + 1);
-        int idNegX = world.getBlockId(x - 1, y, z);
-        int idPosX = world.getBlockId(x + 1, y, z);
-        int idNegXNegZ = world.getBlockId(x - 1, y, z - 1);
-        int idPosXNegZ = world.getBlockId(x + 1, y, z - 1);
-        int idPosXPosZ = world.getBlockId(x + 1, y, z + 1);
-        int idNegXPosZ = world.getBlockId(x - 1, y, z + 1);
-        boolean xNeighbor = idNegX == id || idPosX == id;
-        boolean zNeighbor = idNegZ == id || idPosZ == id;
-        boolean diagNeighbor = idNegXNegZ == id || idPosXNegZ == id || idPosXPosZ == id || idNegXPosZ == id;
+//        int idNegZ = world.getBlockId(x, y, z - 1);
+//        int idPosZ = world.getBlockId(x, y, z + 1);
+//        int idNegX = world.getBlockId(x - 1, y, z);
+//        int idPosX = world.getBlockId(x + 1, y, z);
+//        int idNegXNegZ = world.getBlockId(x - 1, y, z - 1);
+//        int idPosXNegZ = world.getBlockId(x + 1, y, z - 1);
+//        int idPosXPosZ = world.getBlockId(x + 1, y, z + 1);
+//        int idNegXPosZ = world.getBlockId(x - 1, y, z + 1);
+//        boolean xNeighbor = idNegX == id || idPosX == id;
+//        boolean zNeighbor = idNegZ == id || idPosZ == id;
+//        boolean diagNeighbor = idNegXNegZ == id || idPosXNegZ == id || idPosXPosZ == id || idNegXPosZ == id;
         for(int dx = x - 1; dx <= x + 1; dx++) {
             for(int dz = z - 1; dz <= z + 1; dz++) {
                 int id = world.getBlockId(dx, y - 1, dz);
@@ -117,12 +117,11 @@ public class BlockCropsPumpkin
     }
 
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
-        setBlockBoundsBasedOnState(world, x, y, z);
         int meta = world.getBlockMetadata(x, y, z);
         if (meta == 0) {
             return null;
         }
-        return AABB.getTemporaryBB((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
+        return getBlockBoundsFromState(world, x, y, z).move(x, y, z);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockDoor.java
similarity index 80%
rename from src/main/java/net/minecraft/core/block/BlockDoor.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockDoor.java
index df1efadc3..2721ec5a1 100644
--- a/src/main/java/net/minecraft/core/block/BlockDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockDoor.java
@@ -79,26 +79,12 @@ public class BlockDoor extends Block implements IPaintable
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        setBoundsForRotation(getRotation(world.getBlockMetadata(x, y, z)), true);
-        return super.getSelectedBoundingBoxFromPool(world, x, y, z);
+        return getBoundsForRotation(getRotation(world.getBlockMetadata(x, y, z)), false);
     }
 
-    @Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        setBlockBoundsBasedOnState(world, x, y, z);
-        return super.getCollisionBoundingBoxFromPool(world, x, y, z);
-    }
-
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
-    {
-        setBoundsForRotation(getRotation(world.getBlockMetadata(x, y, z)), false);
-    }
-
-    public void setBoundsForRotation(int rotation, boolean drawingSelection)
+    public AABB getBoundsForRotation(int rotation, boolean drawingSelection)
     {
         float top = 1.0f, bottom = 0.0f;
         if (isTop && drawingSelection)
@@ -112,22 +98,17 @@ public class BlockDoor extends Block implements IPaintable
             bottom = 0.0f;
         }
         float f = 0.1875F;
-        setBlockBounds(0.0F, bottom, 0.0F, 1.0F, top, 1.0F);
-        if(rotation == 0)
-        {
-            setBlockBounds(0.0F, bottom, 0.0F, 1.0F, top, f);
-        }
-        if(rotation == 1)
-        {
-            setBlockBounds(1.0F - f, bottom, 0.0F, 1.0F, top, 1.0F);
-        }
-        if(rotation == 2)
-        {
-            setBlockBounds(0.0F, bottom, 1.0F - f, 1.0F, top, 1.0F);
-        }
-        if(rotation == 3)
-        {
-            setBlockBounds(0.0F, bottom, 0.0F, f, top, 1.0F);
+        switch (rotation) {
+            case 0:
+                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, 1.0F, top, f);
+            case 1:
+                return AABB.getTemporaryBB(1.0F - f, bottom, 0.0F, 1.0F, top, 1.0F);
+            case 2:
+                return AABB.getTemporaryBB(0.0F, bottom, 1.0F - f, 1.0F, top, 1.0F);
+            case 3:
+                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, f, top, 1.0F);
+            default:
+                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, 1.0F, top, 1.0F);
         }
     }
     
@@ -148,13 +129,13 @@ public class BlockDoor extends Block implements IPaintable
         int l = world.getBlockMetadata(x, y, z);
         if(isTop)
         {
-            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
+            if(Blocks.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
             {
-            	Block.blocksList[world.getBlockId(x, y - 1, z)].onBlockRightClicked(world, x, y - 1, z, player, side, xPlaced, yPlaced);
+            	Blocks.blocksList[world.getBlockId(x, y - 1, z)].onBlockRightClicked(world, x, y - 1, z, player, side, xPlaced, yPlaced);
             }
             return true;
         }
-        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
+        if(Blocks.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, l ^ MASK_OPENED);
         }
@@ -177,9 +158,9 @@ public class BlockDoor extends Block implements IPaintable
         
         if(isTop)
         {
-            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
+            if(Blocks.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
             {
-            	((BlockDoor)Block.blocksList[world.getBlockId(x, y - 1, z)]).onPoweredBlockChange(world, x, y - 1, z, isPowered);
+            	((BlockDoor)Blocks.blocksList[world.getBlockId(x, y - 1, z)]).onPoweredBlockChange(world, x, y - 1, z, isPowered);
             }
             return;
         }
@@ -188,7 +169,7 @@ public class BlockDoor extends Block implements IPaintable
         {
             return;
         }
-        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
+        if(Blocks.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, meta ^ MASK_OPENED);
         }
@@ -200,22 +181,22 @@ public class BlockDoor extends Block implements IPaintable
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        int i1 = world.getBlockMetadata(x, y, z);
+//        int i1 = world.getBlockMetadata(x, y, z);
         if(isTop)
         {
-        	Block otherBlock = Block.blocksList[world.getBlockId(x, y - 1, z)];
+        	Block otherBlock = Blocks.blocksList[world.getBlockId(x, y - 1, z)];
             if(!(otherBlock instanceof BlockDoor))
             {
                 world.setBlockWithNotify(x, y, z, 0);
             }
-            if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
+            if(blockId > 0 && Blocks.blocksList[blockId].isSignalSource())
             {
                 otherBlock.onNeighborBlockChange(world, x, y - 1, z, blockId);
             }
         } else
         {
             boolean flag = false;
-        	Block otherBlock = Block.blocksList[world.getBlockId(x, y + 1, z)];
+        	Block otherBlock = Blocks.blocksList[world.getBlockId(x, y + 1, z)];
             if(!(otherBlock instanceof BlockDoor))
             {
                 world.setBlockWithNotify(x, y, z, 0);
@@ -239,7 +220,7 @@ public class BlockDoor extends Block implements IPaintable
                     //dropBlockAsItem(world, i, j, k, i1);
                 }
             } else
-            if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
+            if(blockId > 0 && Blocks.blocksList[blockId].isSignalSource())
             {
                 boolean flag1 = world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z);
                 onPoweredBlockChange(world, x, y, z, flag1);
@@ -280,13 +261,6 @@ public class BlockDoor extends Block implements IPaintable
         return null;
     }
 
-    @Override
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
-    {
-        setBlockBoundsBasedOnState(world, x, y, z);
-        return super.collisionRayTrace(world, x, y, z, start, end);
-    }
-
     public int getRotation(int i)
     {
         if ((i & MASK_OPENED) != 0) {
diff --git a/src/main/java/net/minecraft/core/block/BlockFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockFarmland.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/BlockFarmland.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFarmland.java
index b076f8af6..baf6712e1 100644
--- a/src/main/java/net/minecraft/core/block/BlockFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFarmland.java
@@ -67,13 +67,13 @@ public class BlockFarmland extends Block implements IBonemealable
 	}
 
 	@Override
-	public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
+	public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
 		final Material material = world.getBlockMaterial(x, y + 1, z);
 		if (material == Material.vegetable)
 		{
-			setBlockBounds(0, 0, 0, 1, 1, 1);
+			return AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
 		} else {
-			setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
+			return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
 		}
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/BlockFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockFence.java
similarity index 78%
rename from src/main/java/net/minecraft/core/block/BlockFence.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFence.java
index 81d63800a..a57893b55 100644
--- a/src/main/java/net/minecraft/core/block/BlockFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFence.java
@@ -67,17 +67,7 @@ public class BlockFence extends Block implements IPaintable
     @Override
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-    	boolean connectXPos = canConnectTo(world, x + 1, y, z);
-    	boolean connectXNeg = canConnectTo(world, x - 1, y, z);
-    	boolean connectZPos = canConnectTo(world, x, y, z + 1);
-    	boolean connectZNeg = canConnectTo(world, x, y, z - 1);
-        return AABB.getTemporaryBB(x + (connectXNeg ? 0.0f : 0.375f), y, z + (connectZNeg ? 0.0f : 0.375f), x + 1 - (connectXPos ? 0.0f : 0.375f), (float) y + 1.5F, z + 1 - (connectZPos ? 0.0f : 0.375f));
-    }
-    
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-    	return getCollisionBoundingBoxFromPool(world, x, y, z).grow(0, -0.25f, 0).move(0, -0.25f, 0);
+    	return super.getCollisionBoundingBoxFromPool(world, x, y, z).expand(0, 0.5, 0);
     }
 
 //    @Override
@@ -99,18 +89,15 @@ public class BlockFence extends Block implements IPaintable
 //    }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-    	AABB aabb = getCollisionBoundingBoxFromPool(world, x, y, z);
-    	minX = aabb.minX - x;
-    	minY = aabb.minY - y;
-    	minZ = aabb.minZ - z;
-    	maxX = aabb.maxX - x;
-    	maxY = aabb.maxY - y - 0.5F;
-    	maxZ = aabb.maxZ - z;
+        boolean connectXPos = canConnectTo(world, x + 1, y, z);
+        boolean connectXNeg = canConnectTo(world, x - 1, y, z);
+        boolean connectZPos = canConnectTo(world, x, y, z + 1);
+        boolean connectZNeg = canConnectTo(world, x, y, z - 1);
+        return AABB.getTemporaryBB((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
     }
 
-
     @Override
     public boolean isSolidRender()
     {
diff --git a/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java b/game/core/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
similarity index 84%
rename from src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
index a656ae989..82ccb045a 100644
--- a/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
@@ -16,7 +16,7 @@ public class BlockFenceChainlink extends BlockFenceThin
     public boolean canConnectTo(WorldSource world, int x, int y, int z)
     {
         int id = world.getBlockId(x, y, z);
-        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial.isStone() || Block.blocksList[id].blockMaterial.isMetal()));
+        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Blocks.blocksList[id] != null && (Blocks.blocksList[id].blockMaterial.isStone() || Blocks.blocksList[id].blockMaterial.isMetal()));
     }
     
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockFenceGate.java
similarity index 90%
rename from src/main/java/net/minecraft/core/block/BlockFenceGate.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFenceGate.java
index 3b9ed0287..75b791a04 100644
--- a/src/main/java/net/minecraft/core/block/BlockFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFenceGate.java
@@ -52,23 +52,11 @@ public class BlockFenceGate extends Block implements IPaintable
     	}
 
     }
-    
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-    	return getAABBFromMeta(world.getBlockMetadata(x, y, z)).move(x, y, z);
-    }
-    
+
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-    	AABB aabb = getAABBFromMeta(world.getBlockMetadata(x, y, z));
-    	minX = aabb.minX;
-    	minY = aabb.minY;
-    	minZ = aabb.minZ;
-    	maxX = aabb.maxX;
-    	maxY = aabb.maxY;
-    	maxZ = aabb.maxZ;
+    	return getAABBFromMeta(world.getBlockMetadata(x, y, z));
     }
 
 
diff --git a/src/main/java/net/minecraft/core/block/BlockFenceSteel.java b/game/core/src/main/java/net/minecraft/core/block/BlockFenceSteel.java
similarity index 80%
rename from src/main/java/net/minecraft/core/block/BlockFenceSteel.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFenceSteel.java
index 54211a1ef..7bcb11097 100644
--- a/src/main/java/net/minecraft/core/block/BlockFenceSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFenceSteel.java
@@ -12,6 +12,6 @@ public class BlockFenceSteel extends BlockFenceThin {
     @Override
     public boolean canConnectTo(WorldSource world, int x, int y, int z) {
         int id = world.getBlockId(x, y, z);
-        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial.isStone() || Block.blocksList[id].blockMaterial.isMetal()));
+        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Blocks.blocksList[id] != null && (Blocks.blocksList[id].blockMaterial.isStone() || Blocks.blocksList[id].blockMaterial.isMetal()));
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockFenceThin.java b/game/core/src/main/java/net/minecraft/core/block/BlockFenceThin.java
similarity index 76%
rename from src/main/java/net/minecraft/core/block/BlockFenceThin.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFenceThin.java
index ece295b00..3cb49d597 100644
--- a/src/main/java/net/minecraft/core/block/BlockFenceThin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFenceThin.java
@@ -19,31 +19,13 @@ public abstract class BlockFenceThin extends Block
     }
 
     @Override
-    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         boolean connectXPos = canConnectTo(world, x + 1, y, z);
         boolean connectXNeg = canConnectTo(world, x - 1, y, z);
         boolean connectZPos = canConnectTo(world, x, y, z + 1);
         boolean connectZNeg = canConnectTo(world, x, y, z - 1);
-        return AABB.getTemporaryBB(x + (connectXNeg ? 0.0f : 0.375f), y, z + (connectZNeg ? 0.0f : 0.375f), x + 1 - (connectXPos ? 0.0f : 0.375f), (float) y + 1, z + 1 - (connectZPos ? 0.0f : 0.375f));
-    }
-
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return getCollisionBoundingBoxFromPool(world, x, y, z);
-    }
-
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
-    {
-        AABB aabb = getCollisionBoundingBoxFromPool(world, x, y, z);
-        minX = aabb.minX - x;
-        minY = aabb.minY - y;
-        minZ = aabb.minZ - z;
-        maxX = aabb.maxX - x;
-        maxY = aabb.maxY - y;
-        maxZ = aabb.maxZ - z;
+        return AABB.getTemporaryBB((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockFire.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/BlockFire.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFire.java
index c9c2edc0d..9158324f7 100644
--- a/src/main/java/net/minecraft/core/block/BlockFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFire.java
@@ -23,8 +23,8 @@ public class BlockFire extends Block {
 	public static final int BURN_MEDIUM = 20;
 	public static final int BURN_HARD = 5;
 	public static final int BURN_NEVER = 0;
-	private static final int[] flameChance = new int[Block.blocksList.length];
-	private static final int[] burnChance = new int[Block.blocksList.length];
+	private static final int[] flameChance = new int[Blocks.blocksList.length];
+	private static final int[] burnChance = new int[Blocks.blocksList.length];
 
 	public BlockFire(String key, String namespaceId, int id) {
 		super(key, namespaceId, id, Material.fire);
diff --git a/src/main/java/net/minecraft/core/block/BlockFlower.java b/game/core/src/main/java/net/minecraft/core/block/BlockFlower.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/BlockFlower.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFlower.java
index cf3a4f045..8aff9ab5d 100644
--- a/src/main/java/net/minecraft/core/block/BlockFlower.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFlower.java
@@ -49,8 +49,8 @@ public class BlockFlower extends Block implements IBonemealable {
     }
 
     protected boolean mayPlaceOn(int blockId) {
-        if (Block.blocksList[blockId] == null) return false;
-        return Block.blocksList[blockId].hasTag(BlockTags.GROWS_FLOWERS);
+        if (Blocks.blocksList[blockId] == null) return false;
+        return Blocks.blocksList[blockId].hasTag(BlockTags.GROWS_FLOWERS);
     }
 
     @Override
@@ -120,7 +120,7 @@ public class BlockFlower extends Block implements IBonemealable {
                     l1 += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
                     i2 += rand.nextInt(3) - 1;
                     int id1 = world.getBlockId(k1, l1 - 1, i2);
-                    if (Block.blocksList[id1] == null || !Block.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS)) {
+                    if (Blocks.blocksList[id1] == null || !Blocks.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS)) {
                         continue label0;
                     }
                 }
diff --git a/src/main/java/net/minecraft/core/block/BlockFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockFluid.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/BlockFluid.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFluid.java
index 22be11beb..86a1cf1a6 100644
--- a/src/main/java/net/minecraft/core/block/BlockFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFluid.java
@@ -191,12 +191,6 @@ public abstract class BlockFluid extends Block
         super.updateTick(world, x, y, z, rand);
     }
 
-    @Override
-    public int getRenderLayer()
-    {
-        return blockMaterial != Material.water ? 0 : 1;
-    }
-
     @Override
     public void animationTick(World world, int x, int y, int z, Random rand)
     {
@@ -211,7 +205,7 @@ public abstract class BlockFluid extends Block
         if(blockMaterial == Material.lava && world.getBlockMaterial(x, y + 1, z) == Material.air && !world.isBlockOpaqueCube(x, y + 1, z) && rand.nextInt(100) == 0)
         {
             double xOff = (double) x + rand.nextFloat();
-            double yOff = (double) y + maxY;
+            double yOff = (double) y + getBounds().maxY;
             double zOff = (double) z + rand.nextFloat();
             world.spawnParticle("lava", xOff, yOff, zOff, 0.0D, 0.0D, 0.0D, 0);
         }
@@ -321,13 +315,13 @@ public abstract class BlockFluid extends Block
         }
     }
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         float f7 = BlockFluid.getFluidHeight(world, x, y, z, blockMaterial);
         float f8 = BlockFluid.getFluidHeight(world, x, y, z + 1, blockMaterial);
         float f9 = BlockFluid.getFluidHeight(world, x + 1, y, z + 1, blockMaterial);
         float f10 = BlockFluid.getFluidHeight(world, x + 1, y, z, blockMaterial);
-        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, Math.max((f7 + f8 + f9 + f10)/4f, 0.2), 1.0F);
+        return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, Math.max((f7 + f8 + f9 + f10)/4f, 0.2), 1.0F);
     }
 
     public static float getFluidHeight(WorldSource worldSource, int x, int y, int z, Material material)
diff --git a/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
index e8463b54f..05ee752f9 100644
--- a/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
@@ -104,7 +104,7 @@ public class BlockFluidFlowing extends BlockFluid
         	int meta = world.getBlockMetadata(x, y - 1, z);
         	if(id > 0)
             {
-                Block.blocksList[id].dropBlockWithCause(world, EnumDropCause.WORLD, x, y - 1, z, meta, null, null);
+                Blocks.blocksList[id].dropBlockWithCause(world, EnumDropCause.WORLD, x, y - 1, z, meta, null, null);
         	}
             if(localFlowDecay >= 8) {
                 world.setBlockAndMetadataWithNotify(x, y - 1, z, this.id, localFlowDecay);
@@ -155,7 +155,7 @@ public class BlockFluidFlowing extends BlockFluid
                     fizz(world, x, y, z);
                 } else
                 {
-                    Block.blocksList[i1].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+                    Blocks.blocksList[i1].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
                 }
             }
             world.setBlockAndMetadataWithNotify(x, y, z, id, meta);
@@ -269,7 +269,7 @@ public class BlockFluidFlowing extends BlockFluid
     private boolean isFluidBlocking(World world, int x, int y, int z)
     {
         int id = world.getBlockId(x, y, z);
-        if (Block.blocksList[id] == null || Block.blocksList[id] instanceof BlockFluid || Block.blocksList[id].hasTag(BlockTags.BROKEN_BY_FLUIDS)) return false;
+        if (Blocks.blocksList[id] == null || Blocks.blocksList[id] instanceof BlockFluid || Blocks.blocksList[id].hasTag(BlockTags.BROKEN_BY_FLUIDS)) return false;
         return true;
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockFluidStill.java b/game/core/src/main/java/net/minecraft/core/block/BlockFluidStill.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/BlockFluidStill.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockFluidStill.java
index 7a5f4bdd4..08d24723c 100644
--- a/src/main/java/net/minecraft/core/block/BlockFluidStill.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockFluidStill.java
@@ -60,7 +60,7 @@ public class BlockFluidStill extends BlockFluid
                     }
                     continue;
                 }
-                if(Block.blocksList[blockId].blockMaterial.blocksMotion())
+                if(Blocks.blocksList[blockId].blockMaterial.blocksMotion())
                 {
                     return;
                 }
diff --git a/src/main/java/net/minecraft/core/block/BlockGlassTinted.java b/game/core/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/BlockGlassTinted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
index 70a0b6acc..e9139b829 100644
--- a/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
@@ -21,12 +21,6 @@ public class BlockGlassTinted extends BlockGlass
         return true;
     }
 
-    @Override
-    public int getRenderLayer()
-    {
-        return 1;
-    }
-
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
diff --git a/src/main/java/net/minecraft/core/block/BlockGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockGrass.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/BlockGrass.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockGrass.java
index ff174acca..e8264b535 100644
--- a/src/main/java/net/minecraft/core/block/BlockGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockGrass.java
@@ -25,7 +25,7 @@ public class BlockGrass extends Block
         {
             return;
         }
-        if(world.getBlockLightValue(x, y + 1, z) < 4 && Block.lightBlock[world.getBlockId(x, y + 1, z)] > 2)
+        if(world.getBlockLightValue(x, y + 1, z) < 4 && Blocks.lightBlock[world.getBlockId(x, y + 1, z)] > 2)
         {
             if(rand.nextInt(4) != 0)
             {
@@ -39,7 +39,7 @@ public class BlockGrass extends Block
             int i1 = (y + rand.nextInt(5)) - 3;
             int j1 = (z + rand.nextInt(3)) - 1;
             int k1 = world.getBlockId(l, i1 + 1, j1);
-            if(world.getBlockId(l, i1, j1) == Blocks.DIRT.id && world.getBlockLightValue(l, i1 + 1, j1) >= 4 && Block.lightBlock[k1] <= 2)
+            if(world.getBlockId(l, i1, j1) == Blocks.DIRT.id && world.getBlockLightValue(l, i1 + 1, j1) >= 4 && Blocks.lightBlock[k1] <= 2)
             {
                 world.setBlockWithNotify(l, i1, j1, this.id);
             }
diff --git a/src/main/java/net/minecraft/core/block/BlockIce.java b/game/core/src/main/java/net/minecraft/core/block/BlockIce.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/BlockIce.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockIce.java
index ce9e6d447..9844438a9 100644
--- a/src/main/java/net/minecraft/core/block/BlockIce.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockIce.java
@@ -20,12 +20,6 @@ public class BlockIce extends BlockTransparent
         setTicking(true);
     }
 
-    @Override
-    public int getRenderLayer()
-    {
-        return 1;
-    }
-
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
@@ -53,7 +47,7 @@ public class BlockIce extends BlockTransparent
     @Override
 	public void updateTick(World world, int x, int y, int z, Random rand)
     {
-        if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11 - Block.lightBlock[id])
+        if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11 - Blocks.lightBlock[id])
         {
             world.setBlockWithNotify(x, y, z, Blocks.FLUID_WATER_STILL.id);
         }
